<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>TIML: appCNNScene</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIML
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">appCNNScene<div class="ingroups"><a class="el" href="group__appCNN.html">appCNN</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>CNN scene labeling application.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structappCNNSceneDataSet.html">appCNNSceneDataSet</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga656def3c972943463bee38f746074b79"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#ga656def3c972943463bee38f746074b79">appCNNSceneAccuracy</a> (int *labelMatrix, int *trueLabelMatrix, int dim)</td></tr>
<tr class="memdesc:ga656def3c972943463bee38f746074b79"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the labeling accuracy.  <a href="#ga656def3c972943463bee38f746074b79">More...</a><br/></td></tr>
<tr class="separator:ga656def3c972943463bee38f746074b79"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf308ce265a25eed146051684e2da2671"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#gaf308ce265a25eed146051684e2da2671">appCNNSceneSupervisedTraining</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <a class="el" href="structappCNNSceneDataSet.html">appCNNSceneDataSet</a> *dataSet)</td></tr>
<tr class="memdesc:gaf308ce265a25eed146051684e2da2671"><td class="mdescLeft">&#160;</td><td class="mdescRight">Supervised training on the dataset.  <a href="#gaf308ce265a25eed146051684e2da2671">More...</a><br/></td></tr>
<tr class="separator:gaf308ce265a25eed146051684e2da2671"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga38cb0fe9d4fb06709a7e9330911c9431"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga38cb0fe9d4fb06709a7e9330911c9431"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#ga38cb0fe9d4fb06709a7e9330911c9431">appCNNSceneSBDTraining</a> ()</td></tr>
<tr class="memdesc:ga38cb0fe9d4fb06709a7e9330911c9431"><td class="mdescLeft">&#160;</td><td class="mdescRight">Scene labeling training example. <br/></td></tr>
<tr class="separator:ga38cb0fe9d4fb06709a7e9330911c9431"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa2f9ce79a0aaf4a15ef414ac09f0ca7d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gaa2f9ce79a0aaf4a15ef414ac09f0ca7d"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#gaa2f9ce79a0aaf4a15ef414ac09f0ca7d">appCNNSceneSBDTesting</a> ()</td></tr>
<tr class="memdesc:gaa2f9ce79a0aaf4a15ef414ac09f0ca7d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Standford Backgournd Database Scene labeling testing example. <br/></td></tr>
<tr class="separator:gaa2f9ce79a0aaf4a15ef414ac09f0ca7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4924a13edce94afaba52667d78ef7256"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#ga4924a13edce94afaba52667d78ef7256">appCNNSceneClassify</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <a class="el" href="structtimlUtilImage.html">timlUtilImage</a> image, int *labelMatrix, int scale)</td></tr>
<tr class="memdesc:ga4924a13edce94afaba52667d78ef7256"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pixel label classification.  <a href="#ga4924a13edce94afaba52667d78ef7256">More...</a><br/></td></tr>
<tr class="separator:ga4924a13edce94afaba52667d78ef7256"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae6081de152d81c0f91f2ce6f53683848"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#gae6081de152d81c0f91f2ce6f53683848">appCNNSceneShuffleIdx</a> (int *imageIdx, int *rowIdx, int *colIdx, <a class="el" href="structappCNNSceneDataSet.html">appCNNSceneDataSet</a> *dataSet)</td></tr>
<tr class="memdesc:gae6081de152d81c0f91f2ce6f53683848"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shuffles the (image, row, col) index combination from the data set.  <a href="#gae6081de152d81c0f91f2ce6f53683848">More...</a><br/></td></tr>
<tr class="separator:gae6081de152d81c0f91f2ce6f53683848"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga963efff2a4368b6ddc7340d8e24e69bc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#ga963efff2a4368b6ddc7340d8e24e69bc">appCNNSceneGetLabel</a> (int imageIdx, int rowIdx, int colIdx, <a class="el" href="structappCNNSceneDataSet.html">appCNNSceneDataSet</a> *dataSet)</td></tr>
<tr class="memdesc:ga963efff2a4368b6ddc7340d8e24e69bc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the pixel label for (image, row, col) index combination.  <a href="#ga963efff2a4368b6ddc7340d8e24e69bc">More...</a><br/></td></tr>
<tr class="separator:ga963efff2a4368b6ddc7340d8e24e69bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga40b5369e66533ed261ba62199b223cff"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#ga40b5369e66533ed261ba62199b223cff">appCNNSceneGetPatch</a> (int imageIdx, int rowIdx, int colIdx, <a class="el" href="structappCNNSceneDataSet.html">appCNNSceneDataSet</a> *dataSet, float *patch)</td></tr>
<tr class="memdesc:ga40b5369e66533ed261ba62199b223cff"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the image patch for (image, row, col) index combination.  <a href="#ga40b5369e66533ed261ba62199b223cff">More...</a><br/></td></tr>
<tr class="separator:ga40b5369e66533ed261ba62199b223cff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad77aeeb63649011f260d9c475bef945d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#gad77aeeb63649011f260d9c475bef945d">appCNNSceneClassifyOpenMP</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> **cnnTeam, int teamNum, float *data, int row, int col, int channel, int *labelMatrix, int scale)</td></tr>
<tr class="memdesc:gad77aeeb63649011f260d9c475bef945d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Supervised training on the dataset using openmp.  <a href="#gad77aeeb63649011f260d9c475bef945d">More...</a><br/></td></tr>
<tr class="separator:gad77aeeb63649011f260d9c475bef945d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga99dbed533d0ee1089e655bb3bc507a62"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNScene.html#ga99dbed533d0ee1089e655bb3bc507a62">appCNNSceneLabelMatrix</a> (float *map, int row, int col, int channel, int m, int k, int *labelMatrix, int numRow, int numCol)</td></tr>
<tr class="memdesc:ga99dbed533d0ee1089e655bb3bc507a62"><td class="mdescLeft">&#160;</td><td class="mdescRight">Fill the label matrix.  <a href="#ga99dbed533d0ee1089e655bb3bc507a62">More...</a><br/></td></tr>
<tr class="separator:ga99dbed533d0ee1089e655bb3bc507a62"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>CNN scene labeling application. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga656def3c972943463bee38f746074b79"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float appCNNSceneAccuracy </td>
          <td>(</td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>labelMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>trueLabelMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>dim</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Return the labeling accuracy. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">labelMatrix</td><td>Generated label matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">trueLabelMatrix</td><td>True label matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dim</td><td>Dimension of the label matrix </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Labeling accuracy percentage </dd></dl>

</div>
</div>
<a class="anchor" id="ga4924a13edce94afaba52667d78ef7256"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNSceneClassify </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td>
          <td class="paramname"><em>cnn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structtimlUtilImage.html">timlUtilImage</a>&#160;</td>
          <td class="paramname"><em>image</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>labelMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>scale</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Pixel label classification. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">cnn</td><td>CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">image</td><td>Image </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">labelMatrix</td><td>Generated label matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">scale</td><td>Down scaling factor of the label matrix </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="gad77aeeb63649011f260d9c475bef945d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNSceneClassifyOpenMP </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> **&#160;</td>
          <td class="paramname"><em>cnnTeam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>teamNum</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>row</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>col</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>labelMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>scale</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Supervised training on the dataset using openmp. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">cnnTeam</td><td>An array of CNNs that share the same parameters </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">teamNum</td><td>Team number </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>Image data </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">row</td><td>Image row </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">col</td><td>Image col </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">channel</td><td>Image channel </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">labelMatrix</td><td>Generated label matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">scale</td><td>Down scaling factor of the label matrix </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga963efff2a4368b6ddc7340d8e24e69bc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNSceneGetLabel </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>imageIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>rowIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>colIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structappCNNSceneDataSet.html">appCNNSceneDataSet</a> *&#160;</td>
          <td class="paramname"><em>dataSet</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Return the pixel label for (image, row, col) index combination. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">imageIdx</td><td>Image index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">rowIdx</td><td>Row index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">colIdx</td><td>Col index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataSet</td><td>Data set </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pixel label </dd></dl>

</div>
</div>
<a class="anchor" id="ga40b5369e66533ed261ba62199b223cff"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNSceneGetPatch </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>imageIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>rowIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>colIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structappCNNSceneDataSet.html">appCNNSceneDataSet</a> *&#160;</td>
          <td class="paramname"><em>dataSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>patch</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Return the image patch for (image, row, col) index combination. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">imageIdx</td><td>image index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">rowIdx</td><td>row index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">colIdx</td><td>col index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataSet</td><td>data set </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">patch</td><td>image patch </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="ga99dbed533d0ee1089e655bb3bc507a62"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNSceneLabelMatrix </td>
          <td>(</td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>map</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>row</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>col</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>k</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>labelMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>numRow</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>numCol</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Fill the label matrix. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">map</td><td>Feature map output of a CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">row</td><td>Image row </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">col</td><td>Image col </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">channel</td><td>Image channel </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">m</td><td>Row Index </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">k</td><td>Col Index </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">labelMatrix</td><td>Label matrix </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">numRow</td><td>Num of rows </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">numCol</td><td>Num of cols </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="gae6081de152d81c0f91f2ce6f53683848"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNSceneShuffleIdx </td>
          <td>(</td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>imageIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>rowIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>colIdx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structappCNNSceneDataSet.html">appCNNSceneDataSet</a> *&#160;</td>
          <td class="paramname"><em>dataSet</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Shuffles the (image, row, col) index combination from the data set. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">imageIdx</td><td>Image index array ptr </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">rowIdx</td><td>Row index array ptr </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">colIdx</td><td>Col index array ptr </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataSet</td><td>Data set </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
<a class="anchor" id="gaf308ce265a25eed146051684e2da2671"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int appCNNSceneSupervisedTraining </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td>
          <td class="paramname"><em>cnn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structappCNNSceneDataSet.html">appCNNSceneDataSet</a> *&#160;</td>
          <td class="paramname"><em>dataSet</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Supervised training on the dataset. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">cnn</td><td>CNN </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataSet</td><td>Data set </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Mar 20 2015 11:26:08 for TIML by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
